%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% COSTRUZIONE DELLA GEOMETRICA DALLA BINOMIALE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Ripetiamo m volte una serie di n lanci di una moneta con peso p
p = 0.5;
n = 20;
m = 500;
b = binornd(1, p, m, n);

% Creiamo un vettore colonna atto a contenere il numero di lanci prima
% di un successo dedotti dalla matrice b

k = zeros(m , 1);

% Riempiamo il vettore con i risultati

for i = 1:m
   k(i) = min(find(b(i,:)));
end

% Prepariamo i dati per la rappresentazione della distribuzione di frequenza

[alfa, beta] = hist(k, 1:max(k));
alfa = alfa/m;

% Ora prepariamo la densit di probabilit della legge geometrica

gamma = geopdf(beta,p);
gamma = gamma/sum(gamma);

% E infine confrontiamo i dati in un grafico

plot(beta, alfa ,'g', beta , gamma,'r')