%    istbin.m

%    GENERA NUMERI A DISTRIBUZIONE BINOMIALE
%    DI PARAMETRI (n,p).ISTOGRAMMA FREQ.ASS. E REL.
%    DENSITA' TEORICA.CONFRONTO CON
%    DENSITA' GAUSSIANA N(np,np(1-p)): 

%    Applicazione del teorema centrale del limite   

clear;
p=input('parametro "p" della binomiale? ');
n=input('parametro "n" della binomiale? ' );
m=input('quanti numeri genero? ' );

t=cputime;
xx=rand(n,m);                  % GENERA MATRICE nxm A DISTRIBUZIONE 
for i=1:n                           % BERNOULLIANA
      for j=1:m
            if xx(i,j)<=p
               xx(i,j)=1;
            else 
               xx(i,j)=0;
            end;
      end;
end;

xx=sum(xx);                     % ORA xx  VETTORE DI m NUMERI A 
                                         % DISTRIBUZIONE BIN(n,p)

bins=[0:n];  %
figure(1);
clf;
hold off;
subplot(2,1,1);
hist(xx,bins);                    % FREQUENZE ASSOLUTE
[aa,bb]=hist(xx,bins);
bar(bb,aa,'g');
title(' binomiale: frequenze assolute ');

[ord asc]=hist(xx,bins);
ord=(1/m)*ord;
subplot(2,1,2);
bar(asc,ord,'g');                    % FREQUENZE RELATIVE
title(' binomiale: frequenze relative ');

ord=(1/(asc(2)-asc(1)))*ord;
figure(2);
clf;
hold off;
bar(asc,ord,'g');                    % DENSITA' EMPIRICA
title('densit binomiale empirica ,teorica e gaussiana  ');
hold on;
alt(1)=(1-p)^n;
for i=2:n+1
      alt(i)=cb(n,i-1)*p^(i-1)*(1-p)^(n-i+1); 
end;
plot(bins,alt,'Or');               %DENSITA' TEORICA

xxx=[0:0.2:n];
yyy=((1/sqrt(2*pi*n*p*(1-p))))*exp((-0.5/(n*p*(1-p)))*(xxx-n*p).^2);
plot(xxx,yyy,'b');                % DENSITA'  N(np,np(1-p))

nn=length(bins);              % CUMULATIVA EMPIRICA E TEORICA
cdfe(1)=0;
cdft(1)=0;
for i=1:nn-1
        cdfe(i+1)=cdfe(i)+ord(i);
        cdft(i+1)=cdft(i)+alt(i);
end;
figure(3);
clf;
hold off;
scala(bins,cdfe,'b--');
hold on;
scala(bins,cdft,'r');
title('binomiale: cdf empirica e teorica ');
axis([0 max(xx) 0 1]);
tempodicalcolo=cputime-t


