% ISTPOIS1.M

%	Disegno dell'istogramma di n n.c. a distribuzione
%	Poissoniana(q) e confronto con la distribuzione teorica
%	(a grafico).

clear;
m=input('numero di n.c. da generare?');
q=input('parametro della Poisson');
t=cputime;
x=pois1(q,m);
n=max(x);
bins=[0:n];
alt(1)=exp(-q);
for i=2:n+1
	alt(i)=exp(-q)*(q^(i-1))/fattor(i-1);
end;

figure(1);
clf;
hold off;
subplot(2,1,1);
hist(x,bins);  %questo plotta le frequenze assolute
[aa,bb]=hist(x,bins);
bar(bb,aa,'g');
title('Distr. poissoniana: frequenze assolute ')

figure(1);
subplot(2,1,2);
[ord asc]=hist(x,bins);
ord=(1/m)*ord;
bar(asc,ord,'g');               %questo plotta le frequenze relative 
title('freq. rel. , dens. teor. , cfr. N(q,q)');
hold on;
plot(bins,alt,'Or');
hold on;
xxx=[0:0.2:n];                  %confronta P(q) e N(q,q) 
yyy=((1/sqrt(2*pi*q)))*exp((-0.5/(q))*(xxx-q).^2);
plot(xxx,yyy,'b');

nn=length(bins);             %grafico della cumulativa empirica e teorica
cdfe(1)=0;
cdft(1)=0;
for i=1:nn-1
   cdfe(i+1)=cdfe(i)+ord(i);
   cdft(i+1)=cdft(i)+alt(i);
end;
figure(2);
clf;
hold off;
scala(bins,cdfe,'b--');
hold on;
scala(bins,cdft,'r');
title('poissoniana: cdf empirica e teorica');
tempodicalcolo=cputime-t


